/*  $Id: CObj.cc,v 1.9 1999/07/16 20:18:49 shaggy Exp $
 *      
 *      relative path: lib/cparse
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <stdx1.h>
#include <defines>
#include <ldefines>
#include <vStrTab>

#include "CObj.hh"


size_t Object::_sizeof() const
{
	if(type()) 
		return type()->_sizeof();
	else
		return 0;
}


/*
obj_t Object::operator() (obj_t obj)
{
	return obj;
}
*/
 


// this should be an object describing the type:
obj_t Type_Integral;

obj_t Type_PtrTo;

obj_t Type_RefTo;

obj_t Type_Qualifier;

obj_t Type_Array;

obj_t Type_Func;
obj_t Type_Params;
obj_t Type_Method;

obj_t Type_Aggr;

obj_Integral Type_char(8, 3, true, false);
obj_Integral Type_schar(8, 3, true, false);
obj_Integral Type_int(32, 5, true, false);
obj_Integral Type_short(16, 4, true, false);
obj_Integral Type_long(32, 5, true, false);
obj_Integral Type_long2(64, 5, true, false);
obj_Integral Type_uchar(8, 3, false, false);
obj_Integral Type_uint(32, 5, false, false);
obj_Integral Type_ushort(16, 4, false, false);
obj_Integral Type_ulong(32, 5, false, false);
obj_Integral Type_ulong2(64, 5, false, false);

obj_t	Type_void;
obj_t	Type_bool;

obj_t	Type_ptr;
obj_t	Type_ref;

obj_t	Type_List;
obj_t	Type_TokenList;

obj_t	Type_Str;

obj_t	Type_wchar;
obj_t	Type_float;
obj_t	Type_double;

obj_t	Type_null;


/////////////////////////////////////////////////////////////////////////
/*
	Any object dervied from a dynamic type
	will need that type (the one with the dynamic info)
	passed to it

	Or perhaps that type should be "*this"
	and the original object should be passed separately?

	Perhaps all OO calls should always pass the object in
	as "obj_t *This" ?

	Then, objects that need to dynamically resize or retype
	themselves (or change their storage class for resizing)
	can do so...
	Call it 'This', 'self', 'Self', 'obj_this'...?


	Type notions:
		is_of:		type is, or is derived from
		is type:	type is exactly
		type:		get the exact type of the object
		rtype:		get the type referred to or returned by
		rptr:		get the data pointer referred to 
		robj:		get the object referred to (type, ptr)
*/

#if 0


size_t
PtrTo::_sizeof(obj_t *Self) const
{
	if(Self->is_type(Type_PtrTo))
		return sizeof(PtrTo);
	else
		return sizeof(void*);
}


obj_t
PtrTo::ref(obj_t *Self) const
{
	if(Self->is_type(Type_PtrTo))
		return type pointed to
	else
		return data pointed to
}


obj_t
obj_PtrTo::ref(type_t type) const
{
	if(is_type(Type_PtrTo)) {
		PtrTo *This = (PtrTo*)objptr()->get_
		return *objptr()->get_;
	} else {
		Object obj(
	}
}
#endif

/////////////////////////////////////////////////////////////////////////

#if 0
size_t
obj_Integral::_sizeof() const
{
	if(is_type(Type_Integral))
		return sizeof(Integral);
	else
		return 
}

/////////////////////////////////////////////////////////////////////////

size_t
obj_bool::_sizeof() const
{
	return sizeof(bool);
}
#endif
