/*  $Id: ltypes.h,v 1.2 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/m-32bit
 */ 

#ifndef __ltypes_h__
#define __ltypes_h__

#ifndef ASM

#include <btypes.h>

/* for these addressing types,	16 bits would limit to 64K max memory 
 *				(for small embedded systems)
 *				32 bits limits to 4Gb
 *				(for all other systems)
 *				64 bits is wasted for PC machines
 */
typedef _uint32		vaddr_t;	/* virtual addresses (32) */
typedef _int32		svaddr_t;	/* signed virtual addresses (32) */
typedef _uint32		paddr_t;	/* physical addresses (16/32) */

/* for these page number types, 8 bits limits to 1Mb (for small machines)
 *				16 bits limits to 256Mb (most machines)
 *				32 bits limits to 16Tb (excessive)
 */
typedef _uint16		vpage_t;	/* virtual page numbers (16/32) */
typedef _uint16		ppage_t;	/* physical page numbers (8/16/32) */

typedef _uint16		ref_t;		/* 64K max references */


#endif

#endif

