// %edpatch%

:head
/*  $Id: string.cc,v 1.8 1999/07/16 20:18:50 shaggy Exp $
 *     string operations optimized for i386
 *      
 *      relative path: lib/posix/m-i386
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#pragma Make Flags_Banned += -pedantic

#define Q(n)	#n
#ifdef __ELF__
#	define C(n)	Q(n)
#else
#	define C(n)	Q(_##n)
#endif
.

:override strcpy
asm("
.globl "C(strcpy)"
"C(strcpy)":
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	pushl	%esi	
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
1:	lodsb
	stosb	
	cmpb	$0,%al
	jnz	1b
	mov	12(%ebp),%eax
	popl	%esi
	popl	%edi
	leave
	ret
");
.

:override strcat
asm("
.globl "C(strcat)"
"C(strcat)":
	pushl	%ebp	
	movl	%esp,%ebp
	pushl	%edi	
	pushl	%esi	
	movl	8(%ebp),%esi
1:	lodsb	
	cmpb	$0,%al	
	jnz	1b
	leal	-1(%esi),%edi
	movl	12(%ebp),%esi
1:	lodsb	
	stosb
	cmpb	$0,%al	
	jnz	1b
	mov	8(%ebp),%eax
	popl	%esi
	popl	%edi
	leave	
	ret
");
.

:override strlen
asm("
.globl "C(strlen)"
"C(strlen)":	
	pushl	%ebp	
	movl	%esp,%ebp
	pushl	%esi		
	movl	8(%ebp),%esi
1:	lodsb		
	cmpb	$0,%al
	jnz	1b
	movl	%esi,%eax	
	subl	8(%ebp),%eax
	decl	%eax	
	popl	%esi
	leave	
	ret	
");
.

