/*  $Id: termios.h,v 1.2 1999/07/16 20:18:50 shaggy Exp $
 *      relative path: ./lib/posix
 */

#ifndef __termios_h__
#define __termios_h__

#include "_stdinc.h"

_extern_C_begin

#ifdef _POSIX_SOURCE

/* real values should have been used for the rates all along... */
#define B0	0
#define B50	50
#define B75	75
#define B110	110
#define B134	134
#define B150	150
#define B200	200
#define B300	300
#define B600	600
#define B1200	1200
#define B1800	1800
#define B2400	2400
#define B4800	4800
#define B9600	9600
#define B19200	19200
#define B38400	38400

#define BRKINT
#define CLOCAL
#define CREAD
#define CS5
#define CS6
#define CS7
#define CS8
#define CSIZE
#define CSTOPB
#define ECHO
#define ECHOE
#define ECHOK
#define ECHONL
#define HUPCL
#define ICANON
#define ICRNL
#define IEXTEN
#define IGNBRK
#define IGNCR
#define IGNPAR
#define IGNLCR
#define INPCK
#define ISIG
#define ISTRIP
#define IXOFF
#define IXON
#define NCCS
#define NOFLSH
#define OPOST
#define PARENB
#define PARMRK
#define PARODD
#define TCIFLUSH
#define TCIOFF
#define TCIOFLUSH
#define TCION
#define TCOFLUSH
#define TCOOFF
#define TCOON
#define TCSADRAIN
#define TCSAFLUSH
#define TCSANOW
#define TOSTOP
#define VEOF
#define VEOL
#define VERASE
#define VINTR
#define VKILL
#define VMIN
#define VQUIT
#define VSTART
#define VSTOP
#define VSUSP
#define VTIME

typedef _cc_t cc_t;
typedef _speed_t speed_t;
typedef _tcflag_t tcflag_t;

struct termios {
	tcflag_t	c_iflag;
	tcflag_t	c_oflag;
	tcflag_t	c_cflag;
	tcflag_t	c_lflag;
	cc_t		c_cc;
};

speed_t cfgetispeed(const struct termios *p);
speed_t cfgetospeed(const struct termios *p);
int cfsetispeed(struct termios *p, speed_t speed);
int cfsetospeed(struct termios *p, speed_t speed);
int tcdrain(int fd);
int tcflow(int fd, int action);
int tcflush(int fd, int how);
int tcgetattr(int fd, struct termios *p);
int tcsendbreak(int fd, int duration);
int tcsetattr(int fd, int options, const struct termios *tp);

#endif

_extern_C_end

#endif	/* __string_h__ */
