/*  $Id: SymTab.hh,v 1.12 1999/07/16 20:18:51 shaggy Exp $
 *      Symbol Table support
 */     

#ifndef __SymTab_h__
#define __SymTab_h__

#include <stdx1.h>
#include <defines>
#include <vStrTab>
#include <vSymTab>

// just a linked-list for now, although this needs to be changed
// in the future for efficiency

class SymTab : public vSymTab {
private:
	vSymTab *_parent;
	vStrTab *_strtab;
	void *_data;
	struct _SymEntry {
		Id	id;
		Val	val;
		_SymEntry *next;	// next sequential entry
		_SymEntry *cnext;	// next cached entry
	};
	_SymEntry *_first;
	mutable _SymEntry *_cache;
	mutable _SymEntry *_inext;	// next index entry
	mutable uint	   _inum;	// next index number
public:
	SymTab(vStrTab *strtab);
	SymTab(vSymTab *parent);
	SymTab(vSymTab *parent, void *data);
	~SymTab();
	bool get(Id id, Val &val) const;
	bool set(Id id, Val val);
	bool add(Id id, Val val);
	bool del(Id id);
	Id index(uint n) const;
	vSymTab* parent() const;
	bool parent(vSymTab*);
	void* data() const;
	bool data(void*);
	vStrTab* strtab() const;
	SymTab* transplant();
};


/*
class obj_SymTab : public Object {
public:
	obj_SymTab() : Object(Type_vSymTab, Alloc)
		{ _ref.ptr = new SymTab(); }
	obj_SymTab(vSymTab *parent) : Object(Type_vSymTab, Alloc)
		{ _ref.ptr = new SymTab(parent); }
	obj_SymTab(SymTab &data) : Object(Type_vSymTab, Auto)
		{ _ref.ptr = &data; }
	obj_SymTab(SymTab *data) : Object(Type_vSymTab, Auto)
		{ _ref.ptr = data; }
};
*/

#endif
