
%{
int yyerror(const char *str);
int yylex(int *yylval);
int yydebug = 1;
#define YYPDEBUG
%}

%token IF ELSE
%token NUM
%token CODE


%%

start: stmt;

stmt:
	  CODE
		{ printf("yydebug: %d\n", $1); }
	| IF e stmt
		{ printf("yydebug: %d %d %d\n", $1, $2, $3); $$ = $1+$2+$3; }
	| IF e stmt ELSE stmt 
		{ printf("yydebug: %d %d %d %d %d\n", $1, $2, $3, $4, $5); 
					$$ = $1+$2+$3; }
	;

e:
	NUM
		{ printf("yydebug: %d\n", $1); }
	;

%%

int inp[] = {
	IF,NUM,IF,NUM,CODE,
};
int ntok = sizeof(inp)/sizeof(*inp);
int tnum = 0;

int
yyerror(const char *str)
{
	printf("yyerror: %s\n", str);
}

int
yylex(int *yylval)
{
	if(tnum < ntok) {
		*yylval = tnum+1;
		return inp[tnum++];
	} else
		return 0;
}

main()
{
	yyparse();
}

